#include <FastLED.h> //テープLEDを光らせるためのライブラリ
#define PIN 2 //LEDのDINを接続したArduinoのピン
#define NUM_LEDS 15 //LEDの数
const int trigPin = 12; //センサーのTrigを接続したArduinoのピン
const int echoPin = 11; //センサーのEchoを接続したArduinoのピン
CRGB leds[NUM_LEDS]; //テープLEDの配列初期設定用（変更しない）

void setup(){ //Arduino初期設定：電源ON時・リセット時に実行される
  Serial.begin(9600); //シリアル通信を9600bpsで初期化
  FastLED.addLeds<NEOPIXEL, PIN>(leds, NUM_LEDS); //FastLEDライブラリの初期化
  pinMode(trigPin, OUTPUT); //距離センサーのTrigを接続したArduinoピンの初期設定
  pinMode(echoPin, INPUT); //距離センサーのEchoを接続したArduinoピンの初期設定
}
void loop(){ //実行したいプログラムを記述：繰返し実行される
  long duration; //距離を格納する変数
  long cm; //［cm］単位に変換された距離を格納する変数
  digitalWrite(trigPin, LOW); //超音波をオフにする
  delayMicroseconds(2); //2マイクロ秒待機
  digitalWrite(trigPin, HIGH); //超音波を出力する
  delayMicroseconds(10); //10マイクロ秒待機
  digitalWrite(trigPin, LOW); //超音波をオフにする
  duration = pulseIn(echoPin, HIGH); //センサーからの入力を変数durationに代入
  cm = duration /29 /2; //センサーからの入力を［cm］単位に変換して変数cmに代入
  //シリアルモニタにセンサーから受け取った距離（単位：cm）を表示
  Serial.print(cm);
  Serial.print("cm");
  Serial.println();

  if (cm <= 100){ //計測距離が100cm以下の場合、LEDを赤で点灯
    fill_solid( &(leds[0]), NUM_LEDS, CRGB::Red);
    FastLED.show();
  } else if (cm >= 101){ //計測距離が101cm以上の場合、LEDを青で点灯
    fill_solid( &(leds[0]), NUM_LEDS, CRGB::Blue);
    FastLED.show();
  }
  delay(100); //100ミリ秒（0.1秒）待つ
}
