#include <Adafruit_NeoPixel.h> //NeoPixel LEDを光らせるためのライブラリ
#define PIN 2 //LEDのDINを接続したArduinoのピン
#define NUM_LEDS 24 //LEDの数
const int redPotPin = A0; //可変抵抗1を接続したArduinoのピン：赤色を制御
const int greenPotPin = A1; //可変抵抗2を接続したArduinoのピン：緑色を制御
const int bluePotPin = A2; //可変抵抗3を接続したArduinoのピン：青色を制御
int redValue = 0; //赤のRGB値
int greenValue = 0; //緑のRGB値
int blueValue = 0; //青のRGB値
int redPotValue = 0; //可変抵抗1（赤）の値を保持
int greenPotValue = 0; //可変抵抗2（緑）の値を保持
int bluePotValue = 0; //可変抵抗3（青）の値を保持

//NeoPixelライブラリの初期化
Adafruit_NeoPixel pixels = Adafruit_NeoPixel(NUM_LEDS, PIN, NEO_GRB + NEO_KHZ800);
void setup(){ //Arduino初期設定：電源ON時・リセット時に実行される
  Serial.begin(9600); //シリアル通信を9600bpsで初期化
  pinMode(PIN, OUTPUT); //LEDのDINを接続したArduinoピンの初期設定
}

void loop(){ //実行したいプログラムを記述：繰返し実行される
  //色読み取り
  redPotValue = analogRead(redPotPin); //可変抵抗1（赤）の値を読み取る
  delay(5); //A/D変換して待つ
  greenPotValue = analogRead(greenPotPin); //可変抵抗2（緑）の値を読み取る
  delay(5); //A/D変換して待つ
  bluePotValue = analogRead(bluePotPin); //可変抵抗3（青）の値を読み取る
  
  //読み取った値をLEDに書き込めるようにRGB値に変換
  redValue = map(redPotValue, 0, 1023, 0, 255);
  greenValue = map(greenPotValue, 0, 1023, 0, 255);
  blueValue = map(bluePotValue, 0, 1023, 0, 255);

  for (int i = 0; i < NUM_LEDS; i++){ //LEDに書き込む
    pixels.setPixelColor(i, pixels.Color(redValue, greenValue, blueValue));
    pixels.show();
    delay(50);
  }
}
